"use strict";

var _Reflect$construct = require("@babel/runtime-corejs3/core-js-stable/reflect/construct");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js-stable/object/define-property");

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports["default"] = exports.Mapper = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/assertThisInitialized"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs3/helpers/getPrototypeOf"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/object/keys"));

var _isArray = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/array/is-array"));

var _setImmediate2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/set-immediate"));

var _some = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/some"));

var _map = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/map"));

var _parseInt2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-int"));

var _parseFloat2 = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/parse-float"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/for-each"));

var _indexOf = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/index-of"));

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/json/stringify"));

var _splice = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/splice"));

var _concat = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/instance/concat"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs3/core-js-stable/promise"));

var _es = _interopRequireDefault(require("es"));

var _errors = _interopRequireDefault(require("./errors"));

var _events = require("events");

var _util = _interopRequireDefault(require("util"));

var _validators = _interopRequireDefault(require("./validators"));

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = _Reflect$construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !_Reflect$construct) return false; if (_Reflect$construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(_Reflect$construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var DECORATED_SCHEMA_PARAMETERS = ['required'],
    DEFAULT_NOT_FOUND = 404,
    DEFAULT_SCROLL_DURATION = '30s',
    EVENT_IDENTITY = 'identity',
    EVENT_SUMMARY = 'summary',
    EVENT_VERSION = 'version',
    validTypes = (0, _keys["default"])(_validators["default"]);

function analyze(self) {
  var isValid = _validators["default"].isPOJO(self._mapping) && _validators["default"].isPOJO(self._mapping.properties);

  if (!isValid) {
    throw new _errors["default"].InvalidMappingError('mapping is not an object or is missing properties');
  } // parse properties from mapping


  identifyDynamicMapping(self, self._mapping.dynamic);
  identifyProperties(self, self._mapping.properties); // detect _id.path

  if (self._mapping._id) {
    self._idPath = self._mapping._id.path;
  }

  return;
}

function _bulkUpdate(self, idList, docList, upsert, callback) {
  // ensure idList is an array
  if (!(0, _isArray["default"])(idList)) {
    return (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidParameterError('idList', 'the supplied idList is not an array'));
  } // ensure docList is an array with values


  if (!(0, _isArray["default"])(docList) || !docList.length) {
    return (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidParameterError('docList', 'the supplied docList is either not an array or is empty'));
  } // ensure idList and docList lengths match if appropriate


  if (idList.length > 0 && idList.length !== docList.length) {
    return (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidParameterError('idList', 'the supplied idList and docList arrays are not of the same length'));
  }

  var commands = [],
      isInvalid = false,
      models = [];
  isInvalid = (0, _some["default"])(docList).call(docList, function (doc, i) {
    var _id = idList.length ? idList[i] : undefined,
        model = validateModel(self, doc, undefined, !upsert); // ensure the doc is valid...


    if ((0, _isArray["default"])(model.errors) && model.errors.length) {
      (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidModelError(model.errors[0])); // exit loop due to invalid doc

      return true;
    } // ensure we have an _id


    if (!_id && !model._id) {
      (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidParameterError('_id', _util["default"].format('no _id exists for document at index %d', i))); // exit loop due to no _id

      return true;
    } // ensure all fields are properly typed


    coerceProperties(self, model.clone); // populate the bulk commands array with document details

    commands.push({
      update: {
        _id: _id || model._id,
        _index: self._options._index
      }
    }, {
      doc: model.clone,
      'doc_as_upsert': upsert ? true : undefined
    }); // store the model for later retrieval

    models.push(model.clone);
    return false;
  }); // check if callback has already been called

  if (isInvalid) {
    return;
  }

  return ensureInitialize(self, function (err) {
    if (err) {
      return callback(err);
    } // perform bulk index operation


    return self._client.bulk(commands, function (err, result) {
      var _context2;

      if (err) {
        return callback(err);
      } // check for an error in the results


      if (result && result.items) {
        var _context;

        (0, _some["default"])(_context = result.items).call(_context, function (item, i) {
          if (item && item.update && item.update.error) {
            err = new _errors["default"].InvalidParameterError('docList', _util["default"].format('unable to perform bulk operation with document %d', i)); // carry forward any additional details

            err.desc = item.update.error;
            err.statusCode = item.update.status;
            return true;
          }

          return false;
        });
      } // return if an error was found


      if (err) {
        return callback(err);
      } // return


      return callback(null, models, (0, _map["default"])(_context2 = result.items || []).call(_context2, function (item) {
        if (item && item.update) {
          return item.update._version;
        }

        return null;
      }));
    });
  });
}

function coerceValue(fieldValue, type) {
  var _context3, _context4, _context5;

  // if type should be a string, return
  if ((0, _some["default"])(_context3 = ['attachment', 'binary', 'ip', 'keyword', 'string', 'text']).call(_context3, function (matchType) {
    return type === matchType;
  })) {
    if (fieldValue && typeof fieldValue !== 'string') {
      return fieldValue.toString();
    }

    return fieldValue;
  } // if type should be a date, coerce


  if (type === 'date') {
    return new Date(fieldValue);
  } // if type should be a boolean, coerce


  if (type === 'boolean') {
    return fieldValue !== false && fieldValue !== 'false' && fieldValue !== 'no' && fieldValue !== 'off' && fieldValue !== 0 && fieldValue !== '0';
  } // if type should be a number, coerce


  if ((0, _some["default"])(_context4 = ['byte', 'integer', 'long', 'short']).call(_context4, function (matchType) {
    return type === matchType;
  })) {
    return (0, _parseInt2["default"])(fieldValue, 10);
  } // numbers with decimals...


  if ((0, _some["default"])(_context5 = ['double', 'float']).call(_context5, function (matchType) {
    return type === matchType;
  })) {
    return (0, _parseFloat2["default"])(fieldValue);
  }

  return fieldValue;
}

function coerceProperties(self, model, parentPath) {
  var _context6;

  // handle arrays
  if ((0, _isArray["default"])(model)) {
    (0, _forEach["default"])(model).call(model, function (value) {
      return coerceProperties(self, value, parentPath);
    });
    return;
  }

  (0, _forEach["default"])(_context6 = (0, _keys["default"])(model)).call(_context6, function (fieldName) {
    var fieldPath = parentPath ? [parentPath, fieldName].join('.') : fieldName,
        fieldValue = model[fieldName],
        type = self._fields[fieldPath] ? self._fields[fieldPath].type : undefined; // handle sub documents

    if (_validators["default"].isPOJO(fieldValue)) {
      var _context7;

      if (!(0, _some["default"])(_context7 = ['object', 'geo_point', 'geo_shape']).call(_context7, function (matchType) {
        return type === matchType;
      })) {
        // a true sub-document within the mapping requiring further coersion
        coerceProperties(self, fieldValue, fieldPath);
      }

      return;
    } // handle arrays of types properly


    if ((0, _isArray["default"])(fieldValue)) {
      (0, _forEach["default"])(fieldValue).call(fieldValue, function (subValue, i) {
        return model[fieldName][i] = coerceValue(subValue, type);
      });
      return;
    } // individual type values (not arrays)


    model[fieldName] = coerceValue(fieldValue, type);
    return;
  });
  return;
}

function ensureInitialize(self, callback) {
  // instance is already initialized
  if (self._isInitialized) {
    return (0, _setImmediate2["default"])(callback);
  } // initialize _index in Elasticsearch


  return initialize(self, callback);
}

function execOrCallback(exec, callback) {
  if (callback) {
    return exec.then(function (result) {
      return callback(null, result);
    })["catch"](callback);
  }

  return exec;
}

function identifyDynamicMapping(self, dynamicMappingType, parentPath) {
  parentPath = parentPath || '.';

  if (typeof self._dynamic[parentPath] === 'undefined') {
    self._dynamic[parentPath] = typeof dynamicMappingType !== 'undefined' ? dynamicMappingType : true;
  }

  return;
}

function identifyProperties(self, documentProperties) {
  var parseProperties = function parseProperties(field, path) {
    var fields = (0, _keys["default"])(field);
    (0, _forEach["default"])(fields).call(fields, function (fieldName) {
      var fieldPath = path ? [path, fieldName].join('.') : fieldName,
          fieldValue = field[fieldName],
          isSubDocument = _validators["default"].isPOJO(fieldValue) && _validators["default"].isPOJO(fieldValue.properties); // handle sub documents


      if (isSubDocument) {
        identifyDynamicMapping(self, fieldValue.dynamic, fieldPath);
        parseProperties(fieldValue.properties, fieldPath);
        return;
      } // ensure we have a type defined


      if (!fieldValue.type) {
        throw new _errors["default"].InvalidMappingError(_util["default"].format('field %s missing type', fieldPath));
      } // ensure the type is valid and supported


      if ((0, _indexOf["default"])(validTypes).call(validTypes, fieldValue.type) < 0) {
        throw new _errors["default"].InvalidMappingError(_util["default"].format('field %s type is invalid: %s', fieldPath, fieldValue.type));
      } // ensure dynamic object field types are properly tracked


      if (fieldValue.type === 'object') {
        self._dynamic[fieldPath] = fieldValue.dynamic || false;
      } // keep track of the fully qualified field name and build a validator


      self._fields[fieldPath] = fieldValue;
      self._fieldValidators[fieldPath] = _validators["default"][fieldValue.type](fieldValue); // track required fields

      if (typeof fieldValue.required === 'boolean' && fieldValue.required) {
        if (typeof self._required[path || '.'] === 'undefined') {
          self._required[path || '.'] = [];
        }

        self._required[path || '.'].push(fieldName);
      }

      return;
    });
  };

  return parseProperties(documentProperties);
}

function initialize(self, callback) {
  var client,
      cloneConfig = _validators["default"].clone(self._options); // if _index exists or not


  client = (0, _es["default"])(cloneConfig);
  return client.indices.exists(function (err, info) {
    if (err) {
      return callback(err);
    }

    var data = {}; // detect when index does not exist

    if (!info.exists) {
      // create the mapping while creating the _index
      data.mappings = prepareMappingForElasticsearch(self._mapping);
      return client.indices.createIndex(data, function (err) {
        if (err) {
          err.desc = '#initialize - unable to create index in Elasticsearch';
          err._index = self._options._index;
          return callback(err);
        } // ensure initialize is not called subsequently for each method


        self._isInitialized = true;
        return callback();
      });
    } // in Elasticsearch 7.x and up, field types can't be changed as 
    // this may invalidate the data that is already indexed
    // ensure initialize is not called subsequently for each method


    self._isInitialized = true;
    return callback();
  });
}

function prepareMappingForElasticsearch(mapping) {
  var preparedMapping = JSON.parse((0, _stringify["default"])(mapping));
  stripDecorations(preparedMapping);
  return preparedMapping;
}

function scrollAndDelete(self, query, scrollId, state, callback) {
  if (typeof state === 'function') {
    callback = state;
    state = {
      count: 0,
      total: 0
    };
  }

  var commands; // exit immediately if bulk removal is complete

  if (state.total > 0 && state.count === state.total) {
    return (0, _setImmediate2["default"])(callback);
  }

  return self._client.scroll({
    scroll: DEFAULT_SCROLL_DURATION
  }, scrollId, function (err, result) {
    if (err) {
      err.desc = '#delete - unable to scan results using scroll identifier';
      err.scrollId = scrollId;
      return callback(err);
    }

    if (result && result.hits && result.hits.hits) {
      // ensure state
      state.count += result.hits.hits.length;
      state.total = state.total || result.hits.total; // build bulk delete commands

      if (result.hits.hits.length) {
        var _context8;

        commands = (0, _map["default"])(_context8 = result.hits.hits).call(_context8, function (hit) {
          return {
            "delete": {
              _id: hit._id,
              _index: self._options._index
            }
          };
        });
      }
    } // call bulk if there are results to remove


    if (commands && commands.length) {
      // perform bulk delete operation
      return self._client.bulk(commands, function (err) {
        if (err) {
          err.desc = '#delete - unable to delete by query';
          err.commands = commands;
          return callback(err);
        } // continue processing


        return scrollAndDelete(self, query, scrollId, state, callback);
      });
    } // return to the caller


    return callback();
  });
}

function stripDecorations(properties) {
  var _context9;

  if (properties.properties) {
    return stripDecorations(properties.properties);
  }

  (0, _forEach["default"])(_context9 = (0, _keys["default"])(properties)).call(_context9, function (field) {
    if (properties[field].properties) {
      return stripDecorations(properties[field].properties);
    }

    (0, _forEach["default"])(DECORATED_SCHEMA_PARAMETERS).call(DECORATED_SCHEMA_PARAMETERS, function (decoratedParameter) {
      properties[field][decoratedParameter] = undefined;
    });
  });
}

function _update(self, _id, doc, upsert, callback) {
  var model = validateModel(self, doc, undefined, !upsert),
      options; // ensure the input doc is valid...

  if ((0, _isArray["default"])(model.errors) && model.errors.length) {
    return (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidModelError(model.errors[0]));
  } // allow overload of _id as POJO to support additional options like TTL


  if (_validators["default"].isPOJO(_id)) {
    options = _id;
  } else {
    // default options when not specified as POJO
    options = {
      _id: _id
    };
  } // assign modelId if appropriate as _id value


  options._id = options._id || model._id; // require _id in order to go further

  if (options._id === null || typeof options._id === 'undefined') {
    return (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidParameterError('_id', '_id parameter is not supplied'));
  } // ensure module is initialized


  return ensureInitialize(self, function (err) {
    if (err) {
      return callback(err);
    } // next, perform index operation with _create to error if doc already exists


    return self._client.update(options, {
      doc: model.clone,
      'doc_as_upsert': upsert ? true : undefined
    }, function (err, result) {
      if (err) {
        err.desc = upsert ? '#upsert - unable to upsert document in Elasticsearch' : '#update - unable to update document in Elasticsearch';
        err._id = options._id;
        return callback(err);
      } // ensure type values are as expected


      coerceProperties(self, model.clone); // return

      return callback(null, model.clone, result._version);
    });
  });
}

function validateModel(self, model, parentPath, skipRequiredFieldCheck) {
  var _context10;

  var missingRequiredFields = self._required[parentPath || '.'],
      result = {
    _id: null,
    clone: null,
    errors: []
  }; // clone these

  if (missingRequiredFields) {
    missingRequiredFields = JSON.parse((0, _stringify["default"])(missingRequiredFields));
  } else {
    missingRequiredFields = [];
  } // ensure we have a root model


  if (!_validators["default"].isPOJO(model) || !(0, _keys["default"])(model).length) {
    if (!parentPath) {
      result.errors.push('model is not an object or is empty');
    }

    return result;
  } // clone the input model


  result.clone = JSON.parse((0, _stringify["default"])(model));
  (0, _some["default"])(_context10 = (0, _keys["default"])(model)).call(_context10, function (field) {
    var dynamic,
        expectedType,
        fieldPath = parentPath ? [parentPath, field].join('.') : field,
        fieldValue = model[field],
        isSubDocumentArray = (0, _isArray["default"])(fieldValue) && typeof self._dynamic[fieldPath] !== 'undefined'; // determine the expected type (if specified)

    expectedType = self._fields[fieldPath] ? self._fields[fieldPath].type : undefined; // check if field matches _id path

    if (self._idPath && self._idPath === fieldPath) {
      result._id = fieldValue;
    } // clear required field when discovered


    if ((0, _indexOf["default"])(missingRequiredFields).call(missingRequiredFields, field) >= 0) {
      (0, _splice["default"])(missingRequiredFields).call(missingRequiredFields, (0, _indexOf["default"])(missingRequiredFields).call(missingRequiredFields, field), 1);
    } // check for sub-documents as arrays


    if (isSubDocumentArray) {
      (0, _some["default"])(fieldValue).call(fieldValue, function (subModel, i) {
        var _context11;

        var fieldResult = validateModel(self, subModel, fieldPath, skipRequiredFieldCheck); // result._id not assigned for an array of sub-documents

        result.clone[field][i] = fieldResult.clone;
        (0, _forEach["default"])(_context11 = fieldResult.errors).call(_context11, function (error) {
          result.errors.push(error.replace(fieldPath, [fieldPath, '[', i, ']'].join('')));
        });
        return fieldResult.errors.length !== 0;
      });
      return result.errors.length !== 0;
    } // check for sub-documents


    if (_validators["default"].isPOJO(model[field]) && expectedType !== 'object') {
      var _context12;

      var fieldResult = validateModel(self, fieldValue, fieldPath, skipRequiredFieldCheck);
      result._id = result._id || fieldResult._id;
      result.clone[field] = fieldResult.clone;
      result.errors = (0, _concat["default"])(_context12 = result.errors).call(_context12, fieldResult.errors);
      return result.errors.length !== 0;
    } // determine if the field is defined in the mapping


    if (typeof self._fields[fieldPath] === 'undefined') {
      dynamic = self._dynamic[parentPath || '.']; // keep the value if the dynamic mapping is true (the default setting)

      if (dynamic === true) {
        return false;
      } // track as error if the dynamic mapping is strict


      if (dynamic === 'strict') {
        result.errors.push(_util["default"].format('%s is not a valid field in the strict type mapping', fieldPath));
        return true;
      } // remove the field if the dynamic mapping is false


      result.clone[field] = undefined;
      return false;
    } // skip when required field check is disabled and the value is empty


    if (skipRequiredFieldCheck && _validators["default"].isUndefined(fieldValue)) {
      return false;
    } // is field an array of values?


    if ((0, _isArray["default"])(fieldValue)) {
      return (0, _some["default"])(fieldValue).call(fieldValue, function (subValue, i) {
        // validate the field value
        if (!self._fieldValidators[fieldPath](subValue)) {
          result.errors.push(_util["default"].format('%s contains an invalid value (%s) at index %d for type %s', fieldPath, model[field], i, self._fields[fieldPath].type));
          return true;
        }

        return false;
      });
    } // validate the field value


    if (!self._fieldValidators[fieldPath](fieldValue)) {
      result.errors.push(_util["default"].format('%s contains an invalid value (%s) for type %s', fieldPath, model[field], self._fields[fieldPath].type));
      return true;
    }

    return false;
  }); // note all missing required fields as errors

  if (!skipRequiredFieldCheck && missingRequiredFields.length) {
    (0, _forEach["default"])(missingRequiredFields).call(missingRequiredFields, function (missingField) {
      result.errors.push(_util["default"].format('field %s%s%s is required', parentPath ? parentPath : '', parentPath ? '.' : '', missingField));
    });
  }

  return result;
}

var Mapper = /*#__PURE__*/function (_EventEmitter) {
  (0, _inherits2["default"])(Mapper, _EventEmitter);

  var _super = _createSuper(Mapper);

  function Mapper(options, mapping) {
    var _this2;

    (0, _classCallCheck2["default"])(this, Mapper);
    _this2 = _super.call(this);

    if (!options._index || typeof options._index !== 'string') {
      throw new Error('_index must be provided');
    } // initialize Mapper properties


    _this2._client = (0, _es["default"])(options);
    _this2._dynamic = {};
    _this2._fields = {};
    _this2._fieldValidators = {};
    _this2._idPath = null;
    _this2._isInitialized = false;
    _this2._options = options;
    _this2._mapping = mapping;
    _this2._required = {}; // analyze the input

    return (0, _possibleConstructorReturn2["default"])(_this2, analyze((0, _assertThisInitialized2["default"])(_this2)));
  }

  (0, _createClass2["default"])(Mapper, [{
    key: "analyzedFields",
    value: function analyzedFields() {
      var _context13;

      var _this = this,
          analyzedFields = [];

      (0, _forEach["default"])(_context13 = (0, _keys["default"])(_this._fields)).call(_context13, function (fieldPath) {
        var _context14;

        // strings are the only types that are analyzed
        if ((0, _indexOf["default"])(_context14 = ['string', 'text']).call(_context14, _this._fields[fieldPath].type) < 0) {
          return;
        }

        if ((_this._fields[fieldPath].index || 'analyzed') === 'analyzed') {
          analyzedFields.push(fieldPath);
        }
      });
      return analyzedFields;
    }
  }, {
    key: "bulkCreate",
    value: function bulkCreate(idList, docList, callback) {
      if (typeof callback === 'undefined' && typeof docList === 'function') {
        callback = docList;
        docList = idList;
        idList = [];
      }

      if (typeof docList === 'undefined' && typeof idList !== 'function') {
        docList = idList;
        idList = [];
      }

      if (typeof idList === 'function') {
        callback = idList;
        docList = [];
        idList = [];
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        var commands = [],
            modelIds = [],
            models = []; // ensure idList is an array

        if (!(0, _isArray["default"])(idList)) {
          return reject(new _errors["default"].InvalidParameterError('idList', 'the supplied idList is not an array'));
        } // ensure docList is an array with values


        if (!(0, _isArray["default"])(docList) || !docList.length) {
          return reject(new _errors["default"].InvalidParameterError('docList', 'the supplied docList is either not an array or is empty'));
        } // ensure idList and docList lengths match if appropriate


        if (idList.length > 0 && idList.length !== docList.length) {
          return reject(new _errors["default"].InvalidParameterError('idList', 'the supplied idList and docList arrays are not of the same length'));
        } // validate supplied documents


        (0, _some["default"])(docList).call(docList, function (doc, i) {
          var _id = idList.length ? idList[i] : undefined,
              model = validateModel(_this, doc); // ensure the doc is valid...


          if ((0, _isArray["default"])(model.errors) && model.errors.length) {
            return reject(new _errors["default"].InvalidModelError(model.errors[0]));
          } // coerce the fields to proper types


          coerceProperties(_this, model.clone); // populate the bulk commands array with document details

          commands.push({
            index: {
              _id: _id || model._id,
              _index: _this._options._index
            }
          }, model.clone); // save the _id and validated model to return later

          if (_id || model._id) {
            modelIds.push(_id || model._id);
          }

          models.push(model.clone);
          return false;
        });
        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          } // perform bulk index operation


          return _this._client.bulk(commands, function (err, result) {
            if (err) {
              return reject(err);
            } // check for an error in the results


            if (result && result.items) {
              var _context15;

              (0, _some["default"])(_context15 = result.items).call(_context15, function (item, i) {
                if (item && item.index && item.index.error) {
                  err = new _errors["default"].InvalidParameterError('docList', _util["default"].format('unable to perform bulk create operation with document %d', i)); // carry forward any additional details

                  err.desc = item.index.error;
                  err.statusCode = item.index.status;
                  return true;
                }

                return false;
              });
            } // return if an error was found


            if (err) {
              return reject(err);
            } // set the idList if it was an empty array


            if (!modelIds.length) {
              var _context16;

              _this.emit(EVENT_IDENTITY, (0, _map["default"])(_context16 = result.items).call(_context16, function (item) {
                return item.index._id;
              }));
            } // return


            return resolve(models);
          });
        });
      }); // execute and return to caller


      return execOrCallback(exec, callback);
    }
  }, {
    key: "bulkDelete",
    value: function bulkDelete(idList, callback) {
      // ensure docList is an array with values
      if (!(0, _isArray["default"])(idList) || !idList.length) {
        return (0, _setImmediate2["default"])(callback, new _errors["default"].InvalidParameterError('idList', 'the supplied idList is either not an array or is empty'));
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        var commands = [];
        (0, _some["default"])(idList).call(idList, function (_id, i) {
          // ensure the _id is valid...
          if (typeof _id === 'undefined' || _id === null) {
            return reject(new _errors["default"].InvalidParameterError('idList', _util["default"].format('_id at index %d is null or undefined', i)));
          } // populate the bulk commands array with document details


          commands.push({
            "delete": {
              _id: _id,
              _index: _this._options._index
            }
          });
          return false;
        });
        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          } // perform bulk delete operation


          return _this._client.bulk(commands, function (err, summary) {
            if (err) {
              return reject(err);
            } // return


            return resolve(summary);
          });
        });
      }); // execute and return to caller


      return execOrCallback(exec, callback);
    }
  }, {
    key: "bulkGet",
    value: function bulkGet(idList, _source, callback) {
      // handle optional _source parameter
      if (!callback && typeof _source === 'function') {
        callback = _source;
        _source = undefined;
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        // ensure idList is an array with values
        if (!(0, _isArray["default"])(idList) || !idList.length) {
          return reject(new _errors["default"].InvalidParameterError('idList', 'the supplied idList is either not an array or is empty'));
        }

        var docs = [];
        (0, _some["default"])(idList).call(idList, function (_id, i) {
          // ensure the _id is valid...
          if (typeof _id === 'undefined' || _id === null) {
            return reject(new _errors["default"].InvalidParameterError('idList', _util["default"].format('_id at index %d is null or undefined', i)));
          } // populate the bulk commands array with document details


          docs.push({
            _id: _id,
            _index: _this._options._index,
            _source: _source
          });
          return false;
        });
        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          } // perform bulk delete operation


          return _this._client.multiGet(docs, function (err, result) {
            var _context17;

            if (err) {
              return reject(err);
            }

            docs = [];
            (0, _forEach["default"])(_context17 = result.docs || []).call(_context17, function (doc) {
              if (doc.found) {
                docs.push(doc._source);
              }
            }); // return

            return resolve(docs);
          });
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "bulkUpdate",
    value: function bulkUpdate(idList, docList, callback) {
      if (typeof callback === 'undefined' && typeof docList === 'function') {
        callback = docList;
        docList = idList;
        idList = [];
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        return _bulkUpdate(_this, idList, docList, false, function (err, result, versions) {
          if (err) {
            return reject(err);
          } // emit the version information


          _this.emit(EVENT_VERSION, versions);

          return resolve(result);
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "bulkUpsert",
    value: function bulkUpsert(idList, docList, callback) {
      if (typeof callback === 'undefined' && typeof docList === 'function') {
        callback = docList;
        docList = idList;
        idList = [];
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        return _bulkUpdate(_this, idList, docList, true, function (err, result, versions) {
          if (err) {
            return reject(err);
          } // emit the version information


          _this.emit(EVENT_VERSION, versions);

          return resolve(result);
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "create",
    value: function create(_id, doc, callback) {
      var _this3 = this;

      if (typeof callback === 'undefined' && typeof doc === 'function') {
        callback = doc;
        doc = _id;
        _id = undefined;
      }

      if (typeof doc === 'undefined' && typeof _id !== 'function') {
        doc = _id;
        _id = undefined;
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        var model = validateModel(_this3, doc),
            options; // ensure the input doc is valid...

        if ((0, _isArray["default"])(model.errors) && model.errors.length) {
          return reject(new _errors["default"].InvalidModelError(model.errors[0]));
        } // allow overload of _id as POJO to support additional options like TTL


        if (_validators["default"].isPOJO(_id)) {
          options = _id;
          options['op_type'] = options['op_type'] || 'index';
        } else {
          // default options when not specified as POJO
          options = {
            _id: _id,
            'op_type': 'index'
          };
        } // assign modelId if appropriate as _id value


        options._id = options._id || model._id; // ensure module is initialized

        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          } // next, perform index operation with _create to error if doc already exists


          return _this._client.index(options, model.clone, function (err, result) {
            if (err) {
              err.desc = '#create - unable to index new document in Elasticsearch';
              err._id = options._id;
              return reject(err);
            } // ensure values are as expected


            coerceProperties(_this, model.clone); // apply the _id if it isn't specified

            if (!options._id) {
              _this.emit(EVENT_IDENTITY, result._id);
            } // return


            return resolve(model.clone);
          });
        });
      }); // execute and return to caller


      return execOrCallback(exec, callback);
    }
  }, {
    key: "delete",
    value: function _delete(_id, callback) {
      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        var options;

        if (_id === null || typeof _id === 'undefined') {
          return reject(new _errors["default"].InvalidParameterError('_id', '_id parameter is not supplied'));
        } // allow overload of _id as POJO to support additional options


        if (_validators["default"].isPOJO(_id)) {
          options = _id;
        } else {
          options = {
            _id: _id
          };
        } // ensure either an _id or a query is provided


        if (!options._id && !options.query) {
          return reject(new _errors["default"].InvalidParameterError('_id', '_id or query must be supplied'));
        } // ensure module is initialized


        return ensureInitialize(_this, function (err) {
          if (err) {
            return callback(err);
          } // delete by _id


          if (options._id) {
            return _this._client["delete"](options, function (err, summary) {
              if (err) {
                err.desc = '#delete - unable to delete specified document in Elasticsearch';
                err.options = options;
                return reject(err);
              }

              return resolve(summary);
            });
          } // ensure _source is not retrieved for efficiency


          options._source = false; // search for items matching query and create scroll identifier

          return _this._client.search({
            scroll: DEFAULT_SCROLL_DURATION
          }, options, function (err, result) {
            if (err) {
              err.desc = '#delete - unable to delete based on query in Elasticsearch';
              err.query = options;
              return reject(err);
            }

            var scrollId = result['_scroll_id'],
                summary = {
              acknowledged: true,
              total: result.hits ? result.hits.total : 0
            }; // return if there is nothing to remove

            if (!summary.total) {
              return resolve(summary);
            } // delete by query (using scroll)


            return scrollAndDelete(_this, options, scrollId, function (err) {
              if (err) {
                return reject(err);
              }

              return resolve(summary);
            });
          });
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "fieldExists",
    value: function fieldExists(fieldPath) {
      return typeof this._fields[fieldPath] !== 'undefined';
    }
  }, {
    key: "get",
    value: function get(_id, _source, callback) {
      // handle optional _source parameter when missing
      if (!callback && typeof _source === 'function') {
        callback = _source;
        _source = undefined;
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        if (_id === null || typeof _id === 'undefined') {
          return reject(new _errors["default"].InvalidParameterError('_id', '_id parameter is not supplied'));
        }

        var options; // allow overload of _id as POJO to support additional options

        if (_validators["default"].isPOJO(_id)) {
          options = _id;
          options._source = _source || options._source || true;
        } else {
          options = {
            _id: _id,
            _source: _source || true
          };
        } // ensure module is initialized


        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          } // perform lookup, specifying _source in order to get doc directly


          return _this._client.get(options, function (err, result) {
            // if there is an error, only return it if it's not expected (i.e. 404)
            if (err && err.statusCode !== DEFAULT_NOT_FOUND) {
              err.desc = '#get - unable to get document from Elasticsearch';
              err._id = _id;
              return reject(err);
            } // coerce any result to ensure type values are as expected


            if (result) {
              coerceProperties(_this, result);
            } // return


            return resolve(result || null);
          });
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "parse",
    value: function parse(json, callback) {
      if (typeof callback === 'undefined' && typeof json === 'function') {
        callback = json;
        json = undefined;
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        if (typeof json === 'string') {
          try {
            json = JSON.parse(json);
          } catch (ex) {
            var err = new _errors["default"].InvalidModelError(ex, 'unable to parse JSON');
            return reject(err);
          }
        } // ensure we have a root model


        if (!(0, _isArray["default"])(json) && (!_validators["default"].isPOJO(json) || !(0, _keys["default"])(json).length)) {
          var _err = new _errors["default"].InvalidModelError('supplied model is not an object');

          return reject(_err);
        } // coerce the field values of a cloned object


        var model = JSON.parse((0, _stringify["default"])(json));
        coerceProperties(_this, model); // return to sender

        return resolve(model);
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "search",
    value: function search(options, query, callback) {
      if (typeof callback === 'undefined' && typeof query === 'function') {
        callback = query;
        query = options;
        options = {};
      }

      if (typeof query === 'undefined' && typeof options !== 'function') {
        query = options;
        options = {};
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        var models = [],
            summary = {
          query: query,
          total: 0
        };
        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          }

          return _this._client.search(options, query, function (err, result) {
            if (err) {
              return reject(err);
            } // handle results


            if (result && result.hits && result.hits.hits) {
              var _context18;

              summary.total = result.hits.total;
              (0, _forEach["default"])(_context18 = result.hits.hits).call(_context18, function (hit) {
                // when fields are specified on a search, there is no _source
                if (hit.fields) {
                  models.push(hit.fields);
                  return;
                } // coerce properties and store for return


                coerceProperties(_this, hit._source);
                models.push(hit._source);
                return;
              });
            } // emit the summary


            _this.emit(EVENT_SUMMARY, summary);

            return resolve(models);
          });
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "update",
    value: function update(_id, doc, callback) {
      if (typeof callback === 'undefined' && typeof doc === 'function') {
        callback = doc;
        doc = _id;
        _id = undefined;
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        return _update(_this, _id, doc, false, function (err, result, version) {
          if (err) {
            return reject(err);
          } // emit the version


          _this.emit(EVENT_VERSION, version);

          return resolve(result);
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "upsert",
    value: function upsert(_id, doc, callback) {
      if (typeof callback === 'undefined' && typeof doc === 'function') {
        callback = doc;
        doc = _id;
        _id = undefined;
      }

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        return _update(_this, _id, doc, true, function (err, result, version) {
          if (err) {
            return reject(err);
          } // emit the version


          _this.emit(EVENT_VERSION, version);

          return resolve(result);
        });
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "validate",
    value: function validate(model, callback) {
      var _this4 = this;

      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        var result = validateModel(_this4, model);

        if ((0, _isArray["default"])(result.errors) && result.errors.length) {
          var err = new _errors["default"].InvalidModelError(result.errors[0]);
          return reject(err);
        }

        if (result._id) {
          _this.emit(EVENT_IDENTITY, result._id);
        }

        return resolve(result.clone);
      });

      return execOrCallback(exec, callback);
    }
  }, {
    key: "verifyConnection",
    value: function verifyConnection(callback) {
      var _this = this,
          exec = new _promise["default"](function (resolve, reject) {
        return ensureInitialize(_this, function (err) {
          if (err) {
            return reject(err);
          }

          return resolve();
        });
      });

      return execOrCallback(exec, callback);
    }
  }]);
  return Mapper;
}(_events.EventEmitter);

exports.Mapper = Mapper;
var _default = Mapper;
exports["default"] = _default;
//# sourceMappingURL=mapper.js.map
