# v4.0.0 - 06.23.2021

* Enabled support Elasticsearch v7 and above (not backwards compatible)
  * When creating a new index, the mapping is provided without the type wrapper
  * When mapper is initialized, update mapping no longer occurs if index already exists

# v3.3.0 - 06.22.2021

* Updated dependencies

# v3.2.2 - 10.07.2020

* Updated dependencies

# v3.2.1 - 06.25.2020

* Updated dependencies

# v3.2.0 - 10.12.2019

* Added support for Elasticsearch 6.x in the `QueryBuilder`
* Updated dependencies

# v3.1.4 - 03.25.2019

* Tightened up validation for `float` and `double` values

# v3.1.3 - 03.19.2019

* Updated `es` dependency with tightened request body handling

# v3.1.2 - 03.11.2019

* Fixed issue where default export on index

# v3.1.1 - 03.11.2019

* Adjusted support for `string` types to include `keyword` and `text` types

# v3.1.0 - 03.05.2019

* Updated `es` dependency for Elasticsearch 6.x support

# v3.0.1 - 02.19.2019

* Adjusted module loader for simplicity

# v3.0.0 - 02.19.2019

* Moved to ESNext with Babel transpile
* Updated Node version dependencies for Travis CI

# v2.1.3 - 10.23.2018

* Fixed mapper `initalize` function to support deep cloning of options

# v2.1.2 - 01.29.2018

* Fixed bug in QueryBuilder where `mandatory[missing]` filter was not working because of ElasticSearch `v5` update

# v2.1.1 - 10.30.2017

* Fixed bug where `filtered` query is replaced by `bool` query in ElasticSearch `v5` and higher

# v2.1.0 - 10.19.2017

* Added support for `node-es` `v0.6` and higher as well as ElasticSearch `v5` and higher

# v2.0.4 - 03.01.2017

* Fixed defect where fields within a schema that type `object` did not properly support model validation

# v2.0.3 - 02.24.2017

* Added QueryBuilder so that `mongoose-middleware` style query string syntax can be parsed into an object elasticsearch can understand.

# v2.0.2 - 10.06.2016

* Fixed bug where decorators to the mapping were rejected by versions of Elasticsearch greater than `v2`
* Updated `es` module dependency
* Adjusted module to utilize scan and scroll in conjunction with bulk delete commandsto delete by query as the functionality has been deprecated in Elasticsearch

# v2.0.1 - 09.23.2016

* Fixed bug where sub-documents were not properly validated and cloned prior to sending to Elasticsearch

# v2.0.0 - 07.20.2016

* Introduced Promise capability on all asynchronous operations
* Switched to `eslint` from `jshint`
* Modified signature of the callback for `#create` on instances of `Mapper` - the result supplied to the callback or resolved from the Promise is a single value of a model - if the primary identifier is generated by ES, the value of that identifier will be supplied as `_id` for the model object returned
* Modified signature of the callback for `#bulkCreate` on instances of `Mapper` - the result supplied to the callback or resolved from the Promise is a single array of documents - if the primary identifier is generated by ES, the value of that identifier will be supplied as `_id` for each model object returned
* Added events for `identity`, `summary` and `version` with documentation for use

# v1.0.1 - 06.07.2016

* Added contributor @rmomii
* Adjusted behavior so that fields that any fields that are not specified in the mapping are not returned by unless `dynamic` is explicitly set to `false` in the mapping

# v0.2.18 - 10.21.2015

* Added Mapper#fieldExists to provide an easy way to verify a field exists within a mapping

# v0.2.17 - 10.19.2015

* Added ability for Mapper#delete to remove documents based on a query parameter

# v0.2.16 - 10.16.2015

* Fixed issue where string validation failed on types that can be safely cast as a string

# v0.2.15 - 10.15.2015

* Added ability to specify source filtering when calling `get` and `bulkGet` methods

# v0.2.14 - 10.13.2015

* Fixed an issue where number types formatted as strings were incorrectly failing validation

# v0.2.13 - 10.12.2015

* Fixed an issue where on search, if fields were used, property coerceion of property types worked incorrectly

# v0.2.12 - 10.09.2015

* Fixed an issue where the required check for date type fields failed

# v0.2.11 - 10.09.2015

* Fixed issue where `new Date().toString()` failed date validation

# v0.2.10 - 10.09.2015

* Fixed issue with boolean type recognition

# v0.2.9 - 10.09.2015

* Fixed issue where fields that were array values were improperly converted to a string type during coercion

# v0.2.8 - 10.09.2015

* Now allowing Mapper#update to skip `required` field validation when supplying a partial document

# v0.2.7 - 10.09.2015

* Fixed issue where string field types failed when validating arrays of strings

# v0.2.6 - 10.09.2015

* Adding additional summary data as callback argument for `delete` and `bulkDelete`

# v0.2.5 - 10.08.2015

* Fixed issue where certain field types that contain the value `null` caused an unhandled exception

# v0.2.4 - 10.08.2015

* Added Mapper#analyzedFields

# v0.2.3 - 10.06.2015

* Added Mapper#verifyConnection

# v0.2.2 - 09.28.2015

* Added Mapper#bulkCreate
* Added Mapper#bulkDelete
* Added Mapper#bulkGet
* Added Mapper#bulkUpdate
* Added Mapper#bulkUpsert
* Added Mapper#search

# v0.2.1 - 09.22.2015

* Added coveralls.io support

# v0.2.0 - 09.22.2015

* Renamed Schema to Mapper to better reflect data access pattern used
* Added additional documentation for usage of module
* Added Mapper#create
* Added Mapper#delete
* Added Mapper#get
* Added Mapper#parse
* Added Mapper#update
* Added Mapper#upsert

# v0.1.0 - 08.31.2015

* Initial version of module that supports Mapping validation
